/*
 * Copyright (C) 2016 Red Hat, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package io.syndesis.integration.project.generator;

import java.io.IOException;

import io.syndesis.common.util.MavenProperties;
import io.syndesis.integration.api.IntegrationProjectGenerator;
import io.syndesis.integration.api.IntegrationResourceManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
@EnableConfigurationProperties(ProjectGeneratorConfiguration.class)
public class ProjectGeneratorAutoConfiguration {
    @Autowired
    private ProjectGeneratorConfiguration properties;
    @Autowired
    private IntegrationResourceManager resourceManager;
    @Autowired
    private MavenProperties mavenProperties;

    @Bean
    public IntegrationProjectGenerator integrationProjectGenerator() throws IOException {
        return new ProjectGenerator(properties, resourceManager, mavenProperties);
    }
}
